/*	NSBundle.h
	Dynamically loadable code with resources
  	Copyright 1993, 1994, NeXT, Inc.
	NeXT, Aug 1993
*/

#import <foundation/NSArray.h>

/* This module is a cover/replacement for the old NXBundle with some foundation conveniences;
*/

/***************	Class		***********/

@interface NSBundle:NSObject {
    id		_realBundle;
    BOOL	isLoaded;
}

+ (NSBundle *)bundleWithPath:(NSString *)path;

- initWithPath:(NSString *)path;
    /* Path is the path for the bundle itself, e.g. "/NextApps/MyApp/foo.bundle" */

+ (NSBundle *)mainBundle;

+ (NSBundle *)bundleForClass:cls;

+ (NSString *)pathForResource:(NSString *)name ofType:(NSString *)ext inDirectory:(NSString *)bundlePath withVersion:(int)version;
    /* Returns nil of that path; ext may be nil */
    
- (NSString *)bundlePath;

- classNamed:(NSString *)className;

- principalClass;

- (void)setBundleVersion:(unsigned)version;

- (unsigned)bundleVersion;

- (NSString *)pathForResource:(NSString *)name ofType:(NSString *)ext;

- (NSString *)localizedStringForKey:(NSString *)key value:(NSString *)value comment:(NSString *)comment;

- (NSString *)localizedStringForKey:(NSString *)key value:(NSString *)value comment:(NSString *)comment table:(NSString *)tableName;	/* nil tableName ok for the default */

+ (void)setSystemLanguages:(NSArray *)languages;

+ (void)stripAfterLoading:(BOOL)flag;
    /* Default is YES; NO makes bundles easier to debug */

@end
