/*	NSUtilities.h
	Utilities of all kind; Garbage sink
  	Copyright 1993, 1994, NeXT, Inc.
	NeXT, March 1993
*/

#import <foundation/NSString.h>
#import <foundation/NSDictionary.h>

/***************	Logging		***************/

extern void NSLog(NSString *format, ...);
extern void NSLogv(NSString *format, va_list args);
    /* log message, along with date and process, on stderr;
    An ending \n is added iff none at the end of format; %@ and istrings OK;
    Flushes stderr afterwards */

/***************	ASCII PList encoding		***********/

@interface NSString (NSExtendedStringPListParsing)
    
- propertyList;
    /* understands the PropertyList classes (NSString, NSData, NSArray, NSDictionary);
    May raise */

- (NSDictionary *)propertyListFromStringsFileFormat;
    /* understands the .strings files;
    Using -propertyList should be preferred for non .strings files.
    May raise */

@end

@interface NSDictionary (NSExtendedPListASCII)

- (NSString *)descriptionInStringsFileFormat;
    /* same format as the .strings files */

@end

/***********    Abstract class for Enumerators             ***********/

@interface NSEnumerator:NSObject

- nextObject;
    // returns nil when no more

@end

/***************	Compatibility with NEXTSTEP 3.0		***********/

#import <objc/Object.h>

@interface Object (NSCompatibility)

- (BOOL)respondsToSelector:(SEL)sel;
- (BOOL)conformsToProtocol:protocol;
- (BOOL)isKindOfClass:(Class)cls;
- (BOOL)isMemberOfClass:(Class)cls;
- perform:(SEL)sel withObject:object;
- perform:(SEL)sel withObject:object1 withObject:object2;
- retain;
- (unsigned)retainCount;
- (void)release;
- autorelease;
+ allocWithZone:(NSZone *)zone;
- copyWithZone:(NSZone *)zone;
- (void)dealloc;
+ poseAsClass:(Class)class;
+ (BOOL)instancesRespondToSelector:(SEL)sel;
- (IMP)methodForSelector:(SEL)sel;
+ (IMP)instanceMethodForSelector:(SEL)sel;
- (void)doesNotRecognizeSelector:(SEL)sel;

@end

